#ifndef _PROTO_VIF
#define _PROTO_VIF

#include "protoChannel.h"
#include "protoAddress.h"

/**
 * @class ProtoVif
 *
 * @brief Support virtual interfaces.
 */
class ProtoVif : public ProtoChannel
{
    public:
        static ProtoVif* Create();  // for our "factory" pattern
        virtual ~ProtoVif();

        // Overrides of "Open()" and "Close()" MUST call the ProtoChannel 
        // Open/Close base class methods last/first, respectively
        virtual bool Open(char*         vifName, // this may be modified!
                          unsigned int  vifNameLenMax,
                          ProtoAddress  vifAddr, 
                          unsigned int  maskLen) 
            {return ProtoChannel::Open();}

        virtual void Close()
            {ProtoChannel::Close();}

        virtual bool Write(const char* buffer, unsigned int buflen) = 0;
        
        virtual bool Read(char* buffer, unsigned int& numBytes) = 0;
    
    protected:
        ProtoVif();
          
}; // end class ProtoVif

#endif // _PROTO_VIF
